/*
 Tecnisa - Tecnologia em Informtica

 Nome: Gera_Trab_Prev - 1070_FINSTP_GERA_TRAB_PREV.SQL

 Descrio:
 Grava os dados referentes ao relatrio de Fluxo de Caixa (Formulrio)

 Criao:
 19/03/02 - Jenilson Ferreira

@C:\WIN_PRJ\SQL\SQLSERVER\1070_FINSTP_GERA_TRAB_PREV.SQL
 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'GERA_TRAB_PREV' AND
              TYPE   = 'P' 		AND
              U.UID  = O.UID            AND
              U.NAME = USER)

DROP PROCEDURE GERA_TRAB_PREV
GO

CREATE PROCEDURE GERA_TRAB_PREV
   @P_CDFILIAL    VARCHAR(04),
   @P_NRPREVISAO  VARCHAR(10),
   @P_DTPERIINIC  DATETIME,
   @P_DTPERIFINA  DATETIME,
   @P_CDEMPRESA   VARCHAR(2000),
   @P_SALDOINI    VARCHAR(1) = '1'

AS
   DECLARE @V_NRPAGINA         INTEGER;
   DECLARE @V_NRREGIENCA       VARCHAR(10);
   DECLARE @V_NRCOLUNA         INTEGER;
   DECLARE @V_TOTALDIA         FLOAT;
   DECLARE @V_CTSALDO          INTEGER;
   DECLARE @V_CTCONTA          INTEGER;
   DECLARE @V_TOTMOVIANT       FLOAT;
   DECLARE @V_IDATRASO         VARCHAR(01);
   DECLARE @V_ISEMPTY          VARCHAR(01);

   DECLARE @V_DATA_DTDATA      DATETIME;

   DECLARE @V_BANC_CDEMPRESA  VARCHAR(02);
   DECLARE @V_BANC_CDBANCO    VARCHAR(03);
   DECLARE @V_BANC_NMBANCO    VARCHAR(30);

   DECLARE @V_EMPR_CDEMPRESA   VARCHAR(02);
   DECLARE @V_EMPR_NMEMPRESA   VARCHAR(40);

   DECLARE @V_CLAS_CDCLASSFINA VARCHAR(06);
   DECLARE @V_CLAS_DSCLASSFINA VARCHAR(30);

   DECLARE @V_CNTR_VRATUAREC   FLOAT;
   DECLARE @V_CNTP_VRATUAPAG   FLOAT;

   DECLARE @V_PREVENT_CDCLIENTE  VARCHAR(21);
   DECLARE @V_PREVENT_VRPREVENTR FLOAT;

   DECLARE @V_MOVI_NRPAGIPREV INTEGER;
   DECLARE @V_MOVI_DT01       DATETIME;
   DECLARE @V_MOVI_DT02       DATETIME;
   DECLARE @V_MOVI_DT03       DATETIME;
   DECLARE @V_MOVI_DT04       DATETIME;
   DECLARE @V_MOVI_DT05       DATETIME;
   DECLARE @V_MOVI_DT06       DATETIME;
   DECLARE @V_MOVI_DIA01      FLOAT;
   DECLARE @V_MOVI_DIA02      FLOAT;
   DECLARE @V_MOVI_DIA03      FLOAT;
   DECLARE @V_MOVI_DIA04      FLOAT;
   DECLARE @V_MOVI_DIA05      FLOAT;
   DECLARE @V_MOVI_DIA06      FLOAT;
   DECLARE @V_MOVI_ATRASO     FLOAT;
BEGIN
   /* ----- GRAVA O SALDO DOS BANCOS ----- */
   SET @V_NRREGIENCA = 1;

   DECLARE C_BANC CURSOR FOR
   SELECT DISTINCT CC.CDEMPRESA, BC.CDBANCO, BC.NMBANCO
   FROM CONTCORR CC, BANCO BC
   WHERE (CC.CDBANCO = BC.CDBANCO) AND
         (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CC.CDEMPRESA, BC.CDBANCO;
   OPEN C_BANC;
   FETCH NEXT FROM C_BANC INTO @V_BANC_CDEMPRESA, @V_BANC_CDBANCO, @V_BANC_NMBANCO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRCOLUNA = 1;
      SET @V_NRPAGINA = 1;

      DECLARE C_DATA CURSOR FOR
      SELECT DTDATA
      FROM DATA
      WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
      OPEN C_DATA;
      FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_CTSALDO = COUNT(*)
         FROM CONTCORR CC, SDOCCORR SC
         WHERE
            (CC.CDREDUCONT = SC.CDREDUCONT)      AND
            (CC.CDEMPRESA  = @V_BANC_CDEMPRESA) AND
            (CC.CDBANCO    = @V_BANC_CDBANCO)   AND
            (SC.DTSDOCCORR IN (SELECT MAX(DTSDOCCORR)
                               FROM SDOCCORR
                               WHERE
                                  CDREDUCONT  = SC.CDREDUCONT AND
                                  DTSDOCCORR <= @V_DATA_DTDATA));

         SET @V_TOTALDIA = 0;
         IF (@V_CTSALDO > 0) BEGIN
            SELECT @V_TOTALDIA = (CASE @P_SALDOINI WHEN '1' THEN SUM(VRSDOCCORR) 
                                                  ELSE (SUM(VRSDOCCORR) + SUM(ISNULL(CC.VRLIMITCREDCCOR,0))) END)
            FROM CONTCORR CC, SDOCCORR SC
            WHERE
               (CC.CDREDUCONT = SC.CDREDUCONT)      AND
               (CC.CDEMPRESA  = @V_BANC_CDEMPRESA) AND
               (CC.CDBANCO    = @V_BANC_CDBANCO)   AND
               (SC.DTSDOCCORR IN (SELECT MAX(DTSDOCCORR)
                                  FROM SDOCCORR
                                  WHERE
                                     CDREDUCONT  = SC.CDREDUCONT AND
                                     DTSDOCCORR <= @V_DATA_DTDATA));
         END;

         SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
         IF (@V_NRCOLUNA > 1) BEGIN
            EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                  @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;

         END
         ELSE BEGIN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTDIA01PREV,  VRDIA01PREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               @P_CDFILIAL,     @P_NRPREVISAO, @V_NRREGIENCA,
               @V_NRPAGINA,     '01',          @V_BANC_CDEMPRESA,
               @V_BANC_CDBANCO, @V_BANC_NMBANCO, 0,
               @V_DATA_DTDATA,  @V_TOTALDIA,
               @P_DTPERIINIC,   @P_DTPERIFINA);
         END;

         /* CONTROLA A COLUNA E A PGINA DO RELATRIO*/
         SET @V_NRCOLUNA = @V_NRCOLUNA + 1;
         IF (@V_NRCOLUNA > 6) BEGIN
            SET @V_NRPAGINA   = @V_NRPAGINA + 1;
            SET @V_NRCOLUNA   = 1;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
      END;
      CLOSE C_DATA;
      DEALLOCATE C_DATA;

      SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
      FETCH NEXT FROM C_BANC INTO @V_BANC_CDEMPRESA, @V_BANC_CDBANCO, @V_BANC_NMBANCO;
   END;
   CLOSE C_BANC;
   DEALLOCATE C_BANC;

   /* ----- GRAVA O VALOR DAS CONTAS A RECEBER ----- */

   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      DECLARE C_CLAS CURSOR FOR
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;
      OPEN C_CLAS;
      FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_NRPAGINA = 1;
         /* GRAVA OS VALORES DAS CONTAS A RECEBER EM ATRASO */
         SELECT @V_TOTALDIA = SUM(VRFINALBREC)
         FROM
         (SELECT SUM(CR.VRATUAREC) VRFINALBREC
             FROM
                NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
             WHERE
                BO.CDFILIAL     = CR.CDFILIBOLREC      AND
                BO.NRLANBOLREC  = CR.NRLANBOLREC       AND 
                CR.CDEMPRESA    = @V_EMPR_CDEMPRESA    AND
                CR.CDCLASSFINA  = @V_CLAS_CDCLASSFINA  AND
                CR.DTATUAVENREC <= @P_DTPERIINIC - 2   AND
                CR.IDSTATREC IN ('A', 'E', 'P')        AND
                NF.CDFILIAL     = CR.CDFILIAL          AND
                NF.NRLANCTONF   = CR.NRLANCTONF        AND
                NF.IDSTATUS  IN ('A', 'E')) CR;

         SET @V_IDATRASO = 'N';
         IF (@V_TOTALDIA > 0) BEGIN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               @P_CDFILIAL,         @P_NRPREVISAO,       RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10),
               @V_NRPAGINA,         '02',                @V_EMPR_CDEMPRESA,
               @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA, @V_TOTALDIA,
               @P_DTPERIINIC,       @P_DTPERIFINA);

            SET @V_IDATRASO = 'S';
         END;

         SELECT @V_CTCONTA = COUNT(*)
         FROM CONTARECEBER
         WHERE
            CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
            CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
            DTATUAVENREC BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;

         IF ((@V_IDATRASO = 'S') OR (@V_CTCONTA > 0)) BEGIN
            /* GRAVA OS VALORES DAS CONTAS A RECEBER */
            SET @V_NRCOLUNA = 1;
            DECLARE C_DATA CURSOR FOR
            SELECT DTDATA
            FROM DATA
            WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
            OPEN C_DATA;
            FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_TOTALDIA = 0;
               DECLARE C_CNTR CURSOR FOR
               SELECT SUM(CR.VRATUAREC) VRFINALBREC
                   FROM NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                   WHERE BO.CDFILIAL     = CR.CDFILIAL         AND
                         BO.NRLANBOLREC  = CR.NRLANBOLREC      AND
                         CR.CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
                         CR.CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
                         CR.DTATUAVENREC = @V_DATA_DTDATA      AND
                         CR.IDSTATREC IN ('A', 'E', 'P')       AND
                         NF.CDFILIAL     = CR.CDFILIAL         AND
                         NF.NRLANCTONF   = CR.NRLANCTONF       AND
                         NF.IDSTATUS  IN ('A', 'E');
               OPEN C_CNTR;
               FETCH NEXT FROM C_CNTR INTO @V_CNTR_VRATUAREC;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF (@V_CNTR_VRATUAREC IS NULL) BEGIN
                     SET @V_TOTALDIA = @V_TOTALDIA + 0;
                  END
                  ELSE BEGIN
                     SET @V_TOTALDIA = @V_TOTALDIA + @V_CNTR_VRATUAREC;
                  END;
                  FETCH NEXT FROM C_CNTR INTO @V_CNTR_VRATUAREC;
               END;
               CLOSE C_CNTR;
               DEALLOCATE C_CNTR;

               SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
               IF ((@V_NRCOLUNA > 1) OR (@V_IDATRASO = 'S')) BEGIN
                  EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                        @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
               END
               ELSE BEGIN
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     @P_CDFILIAL,         @P_NRPREVISAO, @V_NRREGIENCA,
                     @V_NRPAGINA,         '02',          @V_EMPR_CDEMPRESA,
                     @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA,
                     @V_DATA_DTDATA,      @V_TOTALDIA,
                     @P_DTPERIINIC,       @P_DTPERIFINA);
               END;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               SET @V_NRCOLUNA  = @V_NRCOLUNA + 1;
               IF (@V_NRCOLUNA > 6) BEGIN
                  SET @V_NRPAGINA   = @V_NRPAGINA + 1;
                  SET @V_NRCOLUNA   = 1;
                  SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
                  SET @V_IDATRASO   = 'N';
               END;
               FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
            END;
            CLOSE C_DATA;
            DEALLOCATE C_DATA;

            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;
      END;
      CLOSE C_CLAS;
      DEALLOCATE C_CLAS;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   /* ----- GRAVA O VALOR DAS CONTAS A PAGAR ----- */
   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      DECLARE C_CLAS CURSOR FOR
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;
      OPEN C_CLAS;
      FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_NRPAGINA = 1;

         /* GRAVA OS VALORES DAS CONTAS A PAGAR EM ATRASO */
         SELECT @V_TOTALDIA = SUM(VRFINALBPAG)
         FROM
         (SELECT SUM(CP.VRATUAPAG) VRFINALBPAG
             FROM
                NOTAFISCAL NF,
                CONTAPAGAR CP,
                BOLETPAGAR BO
             WHERE
                BO.CDFILIAL     = CP.CDFILIBPAG        AND
                BO.NRLANBOLPAG  = CP.NRLANBOLPAG       AND         
                CP.CDEMPRESA    = @V_EMPR_CDEMPRESA    AND
                CP.DTATUAVENPAG <= @P_DTPERIINIC - 2   AND
                CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA  AND
                CP.IDSTATPAG    IN ('A', 'P')          AND
                NF.CDFILIAL     = CP.CDFILIAL          AND
                NF.NRLANCTONF   = CP.NRLANCTONF        AND
                NF.IDSTATUS     = 'A') CP;

         SET @V_IDATRASO = 'N';
         IF (@V_TOTALDIA > 0) BEGIN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO,  NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV,  CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV,  VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               @P_CDFILIAL,         @P_NRPREVISAO,       RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10),
               @V_NRPAGINA,         '03',                @V_EMPR_CDEMPRESA,
               @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA, -@V_TOTALDIA,
               @P_DTPERIINIC,       @P_DTPERIFINA);

            SET @V_IDATRASO = 'S';
         END;

         SELECT @V_CTCONTA = COUNT(*)
         FROM CONTAPAGAR
         WHERE
            CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
            CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
            DTATUAVENPAG BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;

         IF ((@V_IDATRASO = 'S') OR (@V_CTCONTA > 0)) BEGIN
            /* GRAVA OS VALORES DAS CONTAS A PAGAR */
            SET @V_NRCOLUNA = 1;

            DECLARE C_DATA CURSOR FOR
            SELECT DTDATA
            FROM DATA
            WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
            OPEN C_DATA;
            FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_TOTALDIA = 0;

               DECLARE C_CNTP CURSOR FOR
               SELECT SUM(CP.VRATUAPAG) VRFINALBPAG
                   FROM NOTAFISCAL NF, CONTAPAGAR CP, 
                        BOLETPAGAR BO
                   WHERE BO.CDFILIAL     = CP.CDFILIBPAG       AND
                         BO.NRLANBOLPAG  = CP.NRLANBOLPAG      AND 
                         CP.CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
                         CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
                         CP.DTATUAVENPAG = @V_DATA_DTDATA      AND
                         CP.IDSTATPAG    IN ('A', 'P')         AND
                         NF.CDFILIAL     = CP.CDFILIAL         AND
                         NF.NRLANCTONF   = CP.NRLANCTONF       AND
                         NF.IDSTATUS     = 'A';
               OPEN C_CNTP;
               FETCH NEXT FROM C_CNTP INTO @V_CNTP_VRATUAPAG;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF (@V_CNTP_VRATUAPAG IS NULL) BEGIN
                     SET @V_TOTALDIA = @V_TOTALDIA + 0;
                  END
                  ELSE BEGIN
                     SET @V_TOTALDIA = @V_TOTALDIA - @V_CNTP_VRATUAPAG;
                  END;
                  FETCH NEXT FROM C_CNTP INTO @V_CNTP_VRATUAPAG;
               END;
               CLOSE C_CNTP;
               DEALLOCATE C_CNTP;

               SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
               IF ((@V_NRCOLUNA > 1) OR (@V_IDATRASO = 'S')) BEGIN
                  EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                        @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
               END
               ELSE BEGIN
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     @P_CDFILIAL,         @P_NRPREVISAO, @V_NRREGIENCA,
                     @V_NRPAGINA,         '03',          @V_EMPR_CDEMPRESA,
                     @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA,
                     @V_DATA_DTDATA,      @V_TOTALDIA,
                     @P_DTPERIINIC,       @P_DTPERIFINA);
               END;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               SET @V_NRCOLUNA  = @V_NRCOLUNA + 1;
               IF (@V_NRCOLUNA > 6) BEGIN
                  SET @V_NRPAGINA   = @V_NRPAGINA + 1;
                  SET @V_NRCOLUNA   = 1;
                  SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
                  SET @V_IDATRASO   = 'N';
               END;
               FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
            END;
            CLOSE C_DATA;
            DEALLOCATE C_DATA;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;
      END;
      CLOSE C_CLAS;
      DEALLOCATE C_CLAS;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   /* GRAVA OS VALORES DAS PREVISES DE ENTRADA */   
   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRPAGINA = 1;
      SET @V_NRCOLUNA = 1;

      DECLARE C_DATA CURSOR FOR
      SELECT DTDATA
      FROM DATA
      WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
      OPEN C_DATA;
      FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_TOTALDIA = 0;
         DECLARE C_PREVENT CURSOR FOR
         SELECT
            CDCLIENTE,
            SUM(VRPREVENTR) VRPREVENTR
         FROM
            PREVENTRADA
         WHERE
            DTPREVENTR = @V_DATA_DTDATA AND
            CDEMPRESA  = @V_EMPR_CDEMPRESA
         GROUP BY CDCLIENTE
         OPEN C_PREVENT;
         FETCH NEXT FROM C_PREVENT INTO @V_PREVENT_CDCLIENTE, @V_PREVENT_VRPREVENTR;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_CTCONTA = COUNT(CR.CDFILIAL)
            FROM
               NOTAFISCAL   NF,
               CONTARECEBER CR
            WHERE
               CR.CDEMPRESA     = @V_EMPR_CDEMPRESA    AND
               CR.DTORIGVENREC  = @V_DATA_DTDATA       AND
               NF.CDFILIAL      = CR.CDFILIAL          AND
               NF.NRLANCTONF    = CR.NRLANCTONF        AND
               NF.CDCLIENTE     = @V_PREVENT_CDCLIENTE AND
               NF.IDSTATUS  IN ('A', 'E');

            IF @V_CTCONTA = 0 BEGIN
               SET @V_TOTALDIA = @V_TOTALDIA + @V_PREVENT_VRPREVENTR;
            END;
            FETCH NEXT FROM C_PREVENT INTO @V_PREVENT_CDCLIENTE, @V_PREVENT_VRPREVENTR;
         END;
         CLOSE C_PREVENT;
         DEALLOCATE C_PREVENT;

         SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
         IF (@V_NRCOLUNA > 1) BEGIN
            EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                  @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
         END
         ELSE BEGIN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV,
               DTDIA01PREV,  VRDIA01PREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               @P_CDFILIAL,    @P_NRPREVISAO, @V_NRREGIENCA,
               @V_NRPAGINA,    '04',          @V_EMPR_CDEMPRESA,
               '0000000000',   'E',
               @V_DATA_DTDATA, @V_TOTALDIA,
               @P_DTPERIINIC,  @P_DTPERIFINA);
         END;

         /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
         SET @V_NRCOLUNA = @V_NRCOLUNA + 1;
         IF (@V_NRCOLUNA > 6) BEGIN
            SET @V_NRPAGINA   = @V_NRPAGINA + 1;
            SET @V_NRCOLUNA   = 1;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
      END;
      CLOSE C_DATA;
      DEALLOCATE C_DATA;

      SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   /* GRAVA OS VALORES DAS PREVISES DE SAIDA */   
   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRPAGINA = 1;
      SET @V_NRCOLUNA = 1;

      DECLARE C_DATA CURSOR FOR
      SELECT DTDATA
      FROM DATA
      WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
      OPEN C_DATA;
      FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_EMPR_CDEMPRESA = MAX(CDEMPRESA), @V_TOTALDIA = SUM(VRPREVSAIDA)
         FROM PREVSAIDA
         WHERE
            DTPREVSAIDA = @V_DATA_DTDATA AND
            CDEMPRESA   = @V_EMPR_CDEMPRESA;

         SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
         IF (@V_NRCOLUNA > 1) BEGIN
            EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                  @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
         END
         ELSE BEGIN
            IF (@V_EMPR_CDEMPRESA IS NULL) BEGIN
               SELECT @V_EMPR_CDEMPRESA = MAX(CDEMPRESA)
               FROM EMPRESA
               WHERE CDEMPRESA = @V_EMPR_CDEMPRESA;
            END;

            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV,
               DTDIA01PREV,  VRDIA01PREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               @P_CDFILIAL,    @P_NRPREVISAO, @V_NRREGIENCA,
               @V_NRPAGINA,    '05',          @V_EMPR_CDEMPRESA,
               '0000000000',   'E',
               @V_DATA_DTDATA, @V_TOTALDIA,
               @P_DTPERIINIC,  @P_DTPERIFINA);
         END;

         /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
         SET @V_NRCOLUNA = @V_NRCOLUNA + 1;
         IF (@V_NRCOLUNA > 6) BEGIN
            SET @V_NRPAGINA   = @V_NRPAGINA + 1;
            SET @V_NRCOLUNA   = 1;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
      END;
      CLOSE C_DATA;
      DEALLOCATE C_DATA;

      SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   /* GRAVA AS CONTAS A RECEBER PREVISTAS */
   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      DECLARE C_CLAS CURSOR FOR
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;
      OPEN C_CLAS;
      FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_NRPAGINA = 1;
         SET @V_NRCOLUNA = 1;

         SELECT @V_CTCONTA = COUNT(*)
         FROM NOTAFISCAL NF, CONTARECEBER CP
         WHERE
            CP.CDEMPRESA    = @V_EMPR_CDEMPRESA         AND
            CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA       AND
            CP.DTATUAVENREC BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA AND
            NF.CDFILIAL     = CP.CDFILIAL               AND
            NF.NRLANCTONF   = CP.NRLANCTONF             AND
            NF.IDSTATUS     = 'V';

         IF (@V_CTCONTA > 0) BEGIN
            DECLARE C_DATA CURSOR FOR
            SELECT DTDATA
            FROM DATA
            WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
            OPEN C_DATA;
            FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_TOTALDIA = SUM(VRATUAREC)
               FROM
                  NOTAFISCAL NF, CONTARECEBER CP
               WHERE
                  CP.CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
                  CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
                  CP.DTATUAVENREC = @V_DATA_DTDATA      AND
                  NF.CDFILIAL     = CP.CDFILIAL         AND
                  NF.NRLANCTONF   = CP.NRLANCTONF       AND
                  NF.IDSTATUS     = 'V';

               IF (@V_TOTALDIA > 0) BEGIN
                  SET @V_TOTALDIA = @V_TOTALDIA * -1;
               END;

               SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
               IF (@V_NRCOLUNA > 1) BEGIN
                  EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                        @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
               END
               ELSE BEGIN
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     @P_CDFILIAL,         @P_NRPREVISAO, @V_NRREGIENCA,
                     @V_NRPAGINA,         '06',          @V_EMPR_CDEMPRESA,
                     @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA,
                     @V_DATA_DTDATA,      @V_TOTALDIA,
                     @P_DTPERIINIC,       @P_DTPERIFINA);
               END;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               SET @V_NRCOLUNA = @V_NRCOLUNA + 1;
               IF (@V_NRCOLUNA > 6) BEGIN
                  SET @V_NRPAGINA   = @V_NRPAGINA + 1;
                  SET @V_NRCOLUNA   = 1;
                  SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
               END;
               FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
            END;
            CLOSE C_DATA;
            DEALLOCATE C_DATA;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;
      END;
      CLOSE C_CLAS;
      DEALLOCATE C_CLAS;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   /* GRAVA AS CONTAS A PAGAR PREVISTAS */
   DECLARE C_EMPR CURSOR FOR
   SELECT CDEMPRESA, NMEMPRESA
   FROM EMPRESA
   WHERE (@P_CDEMPRESA = 'T' OR CHARINDEX(CDEMPRESA, @P_CDEMPRESA) <> 0)
   ORDER BY CDEMPRESA;
   OPEN C_EMPR;
   FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      DECLARE C_CLAS CURSOR FOR
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;
      OPEN C_CLAS;
      FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_NRPAGINA = 1;
         SET @V_NRCOLUNA = 1;

         SELECT @V_CTCONTA = COUNT(*)
         FROM NOTAFISCAL NF, CONTAPAGAR CP
         WHERE
            CP.CDEMPRESA    = @V_EMPR_CDEMPRESA         AND
            CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA       AND
            CP.DTATUAVENPAG BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA AND
            NF.CDFILIAL     = CP.CDFILIAL               AND
            NF.NRLANCTONF   = CP.NRLANCTONF             AND
            NF.IDSTATUS     = 'V';

         IF (@V_CTCONTA > 0) BEGIN
            DECLARE C_DATA CURSOR FOR
            SELECT DTDATA
            FROM DATA
            WHERE DTDATA BETWEEN (@P_DTPERIINIC - 1) AND @P_DTPERIFINA;
            OPEN C_DATA;
            FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SELECT @V_TOTALDIA = SUM(VRATUAPAG)
               FROM
                  NOTAFISCAL NF, CONTAPAGAR CP
               WHERE
                  CP.CDEMPRESA    = @V_EMPR_CDEMPRESA   AND
                  CP.CDCLASSFINA  = @V_CLAS_CDCLASSFINA AND
                  CP.DTATUAVENPAG = @V_DATA_DTDATA      AND
                  NF.CDFILIAL     = CP.CDFILIAL         AND
                  NF.NRLANCTONF   = CP.NRLANCTONF       AND
                  NF.IDSTATUS     = 'V';

               IF (@V_TOTALDIA > 0) BEGIN
                  SET @V_TOTALDIA = @V_TOTALDIA * -1;
               END;

               SET @V_NRREGIENCA = RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10);
               IF (@V_NRCOLUNA > 1) BEGIN
                  EXEC ALTERA_TRAB_PREV @P_CDFILIAL, @P_NRPREVISAO,  @V_NRREGIENCA,
                                        @V_NRCOLUNA, @V_DATA_DTDATA, @V_TOTALDIA;
               END
               ELSE BEGIN
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     @P_CDFILIAL,         @P_NRPREVISAO, @V_NRREGIENCA,
                     @V_NRPAGINA,         '07',          @V_EMPR_CDEMPRESA,
                     @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA,
                     @V_DATA_DTDATA,      @V_TOTALDIA,
                     @P_DTPERIINIC,       @P_DTPERIFINA);
               END;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               SET @V_NRCOLUNA = @V_NRCOLUNA + 1;
               IF (@V_NRCOLUNA > 6) BEGIN
                  SET @V_NRPAGINA   = @V_NRPAGINA + 1;
                  SET @V_NRCOLUNA   = 1;
                  SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
               END;
               FETCH NEXT FROM C_DATA INTO @V_DATA_DTDATA;
            END;
            CLOSE C_DATA;
            DEALLOCATE C_DATA;
            SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
         END;
         FETCH NEXT FROM C_CLAS INTO @V_CLAS_CDCLASSFINA, @V_CLAS_DSCLASSFINA;
      END;
      CLOSE C_CLAS;
      DEALLOCATE C_CLAS;
      FETCH NEXT FROM C_EMPR INTO @V_EMPR_CDEMPRESA, @V_EMPR_NMEMPRESA;
   END;
   CLOSE C_EMPR;
   DEALLOCATE C_EMPR;

   SET @V_TOTMOVIANT = 0;
   DECLARE C_MOVI CURSOR FOR
   SELECT
      NRPAGIPREV,
      MAX(DTDIA01PREV) DT01 , MAX(DTDIA02PREV) DT02 , MAX(DTDIA03PREV) DT03,
      MAX(DTDIA04PREV) DT04 , MAX(DTDIA05PREV) DT05 , MAX(DTDIA06PREV) DT06,
      SUM(VRDIA01PREV) DIA01, SUM(VRDIA02PREV) DIA02, SUM(VRDIA03PREV) DIA03,
      SUM(VRDIA04PREV) DIA04, SUM(VRDIA05PREV) DIA05, SUM(VRDIA06PREV) DIA06,
      SUM(VRATRASOPREV) ATRASO
   FROM
      TRAB_PREV
   WHERE
      CDFILIPREV = @P_CDFILIAL AND
      NRPREVISAO = @P_NRPREVISAO AND
      CDGRUPPREV <> '01'
   GROUP BY NRPAGIPREV
   OPEN C_MOVI;
   FETCH NEXT FROM C_MOVI INTO @V_MOVI_NRPAGIPREV, @V_MOVI_DT01 , @V_MOVI_DT02 ,
                               @V_MOVI_DT03      , @V_MOVI_DT04 , @V_MOVI_DT05 ,
                               @V_MOVI_DT06      , @V_MOVI_DIA01, @V_MOVI_DIA02,
                               @V_MOVI_DIA03     , @V_MOVI_DIA04, @V_MOVI_DIA05,
                               @V_MOVI_DIA06, @V_MOVI_ATRASO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRREGIENCA = @V_NRREGIENCA + 1;
      INSERT INTO TRAB_PREV(
         CDFILIPREV,   NRPREVISAO, NRREGIPREV,
         NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
         CDITEMPREV,   DSITEMPREV,
         DTDIA01PREV,  VRDIA01PREV,
         DTDIA02PREV,  VRDIA02PREV,
         DTDIA03PREV,  VRDIA03PREV,
         DTDIA04PREV,  VRDIA04PREV,
         DTDIA05PREV,  VRDIA05PREV,
         DTDIA06PREV,  VRDIA06PREV,
         DTINIPERPREV, DTFINPERPREV)
      VALUES(
         @P_CDFILIAL,    @P_NRPREVISAO, RIGHT(REPLICATE('0',10) + @V_NRREGIENCA, 10),
         @V_MOVI_NRPAGIPREV,    '99',         '',
         '',         '',
         @V_MOVI_DT01, @V_TOTMOVIANT + ISNULL(@V_MOVI_ATRASO, 0),
         @V_MOVI_DT02, @V_TOTMOVIANT + @V_MOVI_DIA01 + ISNULL(@V_MOVI_ATRASO, 0),
         @V_MOVI_DT03, @V_TOTMOVIANT + @V_MOVI_DIA01 + @V_MOVI_DIA02 + ISNULL(@V_MOVI_ATRASO, 0),
         @V_MOVI_DT04, @V_TOTMOVIANT + @V_MOVI_DIA01 + @V_MOVI_DIA02 + @V_MOVI_DIA03 + ISNULL(@V_MOVI_ATRASO, 0),
         @V_MOVI_DT05, @V_TOTMOVIANT + @V_MOVI_DIA01 + @V_MOVI_DIA02 + @V_MOVI_DIA03 + @V_MOVI_DIA04 + ISNULL(@V_MOVI_ATRASO, 0),
         @V_MOVI_DT06, @V_TOTMOVIANT + @V_MOVI_DIA01 + @V_MOVI_DIA02 + @V_MOVI_DIA03 + @V_MOVI_DIA04 + @V_MOVI_DIA05 + ISNULL(@V_MOVI_ATRASO, 0),
         @P_DTPERIINIC, @P_DTPERIFINA);

      SET @V_TOTMOVIANT = @V_TOTMOVIANT +
                          ISNULL(@V_MOVI_DIA01, 0) + ISNULL(@V_MOVI_DIA02, 0) + ISNULL(@V_MOVI_DIA03, 0) +
                          ISNULL(@V_MOVI_DIA04, 0) + ISNULL(@V_MOVI_DIA05, 0) + ISNULL(@V_MOVI_DIA06, 0) + ISNULL(@V_MOVI_ATRASO,0);
   FETCH NEXT FROM C_MOVI INTO @V_MOVI_NRPAGIPREV, @V_MOVI_DT01 , @V_MOVI_DT02 ,
                               @V_MOVI_DT03      , @V_MOVI_DT04 , @V_MOVI_DT05 ,
                               @V_MOVI_DT06      , @V_MOVI_DIA01, @V_MOVI_DIA02,
                               @V_MOVI_DIA03     , @V_MOVI_DIA04, @V_MOVI_DIA05,
                               @V_MOVI_DIA06, @V_MOVI_ATRASO;
   END;
   CLOSE C_MOVI;
   DEALLOCATE C_MOVI;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'GERA_TRAB_PREV','5.05.058';
GO

